  /* --------------------------------------------------------------- */
  /* sample.c -- Tollos sample application                           */
  /*                                                                 */
  /* For detailed explanation of this, see:                          */
  /*                                                                 */
  /*   http://speleotrove.com/tollos/Sample_application.html         */
  /*                                                                 */
  /* --------------------------------------------------------------- */

  #include "tollos.h"           // Tollos library
  #define  TOLLOS_IO            // allow use of I/O functions
  
  #include "i2clcd.h"
  
  
    int paAddr=i2cDevice(1, 0x70);
	int pbAddr=i2cDevice(1, 0x73);
	int lcdAddr=i2cDevice(1, 0x20);
	int matAddr=i2cDevice(1, 0x27);
	
	
  /* --------------------------------------------------------------- */
  /* init -- initialization function                                 */
  /*                                                                 */
  /* This is called once, after C and processor initialization.      */
  /* Return 0 to start tick() calls, or 1 to halt (power down).      */
  /* --------------------------------------------------------------- */
  int init(void) {
	lcd_init();
	lcd_print("Welcome to mbed!  \n");
    // Send a string to the host computer terminal
    debugf("%s; sample compiled on %s at %s\n", TOLLOS_VERSION,
           __DATE__, __TIME__);
	debugf("press ? - ok!\n");
    // blink LED4 (if any) for a second
    ledSet(4, LED_INVERT);
    sysPause(1000);             // wait 1000 ms
    ledSet(4, LED_INVERT);

	
	
    // Request that the watchdog timer reset the processor if a
    // tick() call takes more than 2 seconds
    sysSet(SYS_WATCHDOG, 2000);

    return 0;
    } // init


  /* --------------------------------------------------------------- */
  /* tick -- repeating tick function                                 */
  /*                                                                 */
  /* This is called once a tick (default 25 Hz) after init() ends.   */
  /* Return 0 to continue tick() calls, or 1 to halt (power down).   */
  /* --------------------------------------------------------------- */
  int tick(void) {
    static int ticks=0;         // counter
    int c;                      // work
	//int dummy = 0;
    // Change a LED state every second
    ticks++;                    // bump counter
	if (ticks==20) {            // every second ..
      ledSet(1, LED_INVERT);    // .. invert LED1
      }
    if (ticks==25) {            // every second ..   war 25
      ledSet(1, LED_INVERT);    // .. invert LED1
      ticks=0;                  // .. and reset counter
      }

    // Flip Port 1 bit 31 every tick [to watch on a 'scope]
    // On the mbed this is pin 20
    bitSet(PORT1, BIT31, BIT_INVERT);
	
	
	
	
	
    // check the serial input
    c=debugGet();
    if       (c=='1') ledSet(1, LED_INVERT);
     else if (c=='2') ledSet(2, LED_INVERT);
     else if (c=='3') ledSet(3, LED_INVERT);
     else if (c=='4') ledSet(4, LED_INVERT);
	 else if (c=='5') {i2cPutReg(paAddr, 3, 0);
						i2cPutReg(paAddr, 1, 0x55);}
	 else if (c=='6') {i2cPutReg(paAddr, 3, 0);
						i2cPutReg(paAddr, 1, 0xaa);}					
	 else if (c=='7') {i2cPutReg(pbAddr, 3, 0);
						i2cPutReg(pbAddr, 1, 0x55);}
	 else if (c=='8') {i2cPutReg(pbAddr, 3, 0);
						i2cPutReg(pbAddr, 1, 0xaa);}					
	 else if (c=='9') {i2cPutReg(pbAddr, 3, 0xff);}
	 else if (c=='B') i2cPutVal(lcdAddr, 0x40);
	 else if (c=='b') i2cPutVal(lcdAddr, 0);
     else if (c=='x') return 1;                     // power off
     else if (c=='?') {                             // do some queries
      debugf("SysTickTime   %d\n", sysQuery(SYS_TICKTIME));
      debugf("SysTickMax    %d\n", sysQuery(SYS_TICKMAX));
      debugf("SysStackUsed  %d\n", sysQuery(SYS_STACKUSED));
      debugf("SysWatchdog   %d\n", sysQuery(SYS_WATCHDOG));
	  debugf("Tastenbelegung:  \n");
	  debugf("Taste 1: toggle LED1 \n");
	  debugf("Taste 2: toggle LED2 \n");
	  debugf("Taste 3: toggle LED3 \n");
	  debugf("Taste 4: toggle LED4 \n");	  
	  debugf("Taste 5: Ausgabe von 0x55 auf PortA  \n");
	  debugf("Taste 6: Ausgabe von 0xaa auf PortA  \n");
	  debugf("Taste 7: Ausgabe von 0x55 auf PortB  \n");
	  debugf("Taste 8: Ausgabe von 0xaa auf PortB  \n");
	  debugf("Taste 9:PortB --> Eingang  \n");
	  debugf("Taste b:LCD - BL off \n");
	  debugf("Taste B:LCD - BL on \n");
	  debugf("Taste x: Stop --> weiter mit reset \n");
	  debugf("Taste ?: dieses Menue ! \n");
	  
      }
     // other characters (and -1) are ignored

    return 0;
    } // tick
int backlight = OFF;
void lcd_init(void)
{       
        lcd_wait_ms(16);                //-     Wait for more than 15ms after VDD rises to 4.5V
        lcd_write(LCD_D5 | LCD_D4);     //-     Set interface to 8-bit
        lcd_wait_ms(5);                 //-     Wait for more than 4.1ms
        lcd_write(LCD_D5 | LCD_D4);     //-     Set interface to 8-bit
        lcd_wait_ms(1);               //-     Wait for more than 100us        
        lcd_write(LCD_D5 | LCD_D4);     //-     Set interface to 8-bit
        lcd_write(LCD_D5);              //-     Set interface to 4-bit
        //- From now on in 4-bit-Mode
        lcd_command(LCD_4BIT | LCD_2LINE | LCD_5X7);            //-     2-Lines, 5x7-Matrix
		lcd_command(LCD_DISPLAYOFF);                            //-     Display off
		lcd_command(LCD_CLEAR);                                 //-     Clear Screen
		lcd_command(LCD_INCREASE | LCD_DISPLAYSHIFTOFF);        //-     Entrymode (Display Shift: off, Increment Address Counter)
		lcd_command(LCD_DISPLAYON);                             //-     Display on
}
//-     Write byte to display with toggle of enable-bit
void lcd_write(unsigned char value)
{
        lcd_write_i2c(value | LCD_E);           //-     Set enable to high
        lcd_write_i2c(value | LCD_E);           //-     Send data, keep enable high
        lcd_write_i2c(value & (!LCD_E));        //-     Set enable to low
}
//-     Write data to i2c
void lcd_write_i2c(unsigned char value)
{
		
	if (backlight) {
		value |= (1 << LCD_BL_PIN);
	} else {
		value &= ~(1 << LCD_BL_PIN);
	}	
		
        i2cPutVal(lcdAddr, value);
}

void lcd_wait_ms(unsigned short ms)
{
        unsigned short i;
        for(i = 0; i < ms; i++)
        {
                sysPause(1);             // wait 1 ms
        }
}
//-     Issue a command to the display (use the defined commands above)
void lcd_command(unsigned char command)
{
        unsigned char lcddata;
        lcddata = command;
        lcddata >>=  4;
        lcd_write(lcddata);
        lcddata = command;
        lcddata &= 0x0F;
        lcd_write(lcddata);     
}
//-     Put char to cursor position
void lcd_putchar(unsigned char value)
{
        unsigned char lcddata;
        lcddata = value;
        lcddata >>= 4;
        lcddata |= LCD_RS;
        lcd_write(lcddata);
        lcddata = value;
        lcddata &= 0x0F;
        lcddata |= LCD_RS;
        lcd_write(lcddata);
}
//-     Print string to cursor position
void lcd_print(unsigned char *string)
{
        unsigned char i = 0;
        while(string[i] != 0x00)
        {
                lcd_putchar(string[i]);
                i++;
        }
}

/************************************************************************************************
//-     Put char to position
bool lcd_putcharlr(unsigned char line, unsigned char row, unsigned char value)
{
        if(!lcd_gotolr(line, row)) return false;
        lcd_putchar(value);
        
        return true;
}
//-     Print string to position (If string is longer than LCD_ROWS overwrite first chars)(line, row, string)
bool lcd_printlc(unsigned char line, unsigned char row, unsigned char *string)
{
        unsigned char i;
                
        for(i = 0; string[i] != 0x00; i++)
        {
                if (!lcd_putcharlr(line, row, string[i])) return false;
                row++;
                if(row > LCD_ROWS)
                {
                        row = 1;
                }
        }
        return true;
}
//-     Print string to position (If string is longer than LCD_ROWS continue in next line)(line, row, string)
bool lcd_printlrc(unsigned char line, unsigned char row, unsigned char *string)
{
        unsigned char i;
                
        for(i = 0; string[i] != 0x00; i++)
        {
                if(!lcd_putcharlr(line, row, string[i])) return false;
                row++;
                if(row > LCD_ROWS)
                {
                        line++;
                        row = 1;
                }
                if(line > LCD_LINES)
                {
                        line = 1;
                }
        }
        return true;
}
//-     Print string to position (line, row, string)
bool lcd_printlr(unsigned char line, unsigned char row, unsigned char *string)
{
        if(!lcd_gotolr(line, row)) return false;
        lcd_print(string);
        
        return true;
}

//-     Go to position (line, row)
bool lcd_gotolr(unsigned char line, unsigned char row )
{
        unsigned char lcddata;
        
        if(line > LCD_LINES) return false;
        if(row > LCD_ROWS) return false;
        if((line == 0) || (row == 0) ) return false;
                
        lcddata = LCD_D7;
#if LCD_LINES>=2
        if (line == 2) lcddata = LCD_D7 |  (LCD_LINE2 >> 4);
#endif
#if LCD_LINES>=3
        if (line == 3) lcddata = LCD_D7 |  (LCD_LINE3 >> 4);
#endif
#if LCD_LINES>=4
        if (line == 4) lcddata = LCD_D7 |  (LCD_LINE4 >> 4);
#endif
        lcd_write(LCD_E | lcddata);
        lcddata = (row-1);
        lcd_write(LCD_E | lcddata);
        
        return true;    
}
*/
/*
//-     Go to nextline (if next line > LCD_LINES return false)
bool lcd_nextline(void)
{
        unsigned char line = 0x00, row = 0x00;
        lcd_getlr(&line, &row);
        if (!lcd_gotolr(line + 1, 1)) return false;
                else return true;
}

//-     Read data from i2c
unsigned char lcd_read_i2c(void)
{
        unsigned char lcddata = 0x00;
        i2c_start_wait(LCD_I2C_DEVICE+I2C_READ);
        lcddata = i2c_readNak();
        i2c_stop();
        return lcddata;
}

//-     Read data from display over i2c (second nibble corresponds to highbyte or lowbyte)
unsigned char lcd_read(bool mode)
{
        unsigned char lcddata;
        if(mode == LCD_DATA)
                lcd_write_i2c(LCD_E | LCD_RS | LCD_RW | LCD_D4 | LCD_D5 | LCD_D6 | LCD_D7);
        else
                lcd_write_i2c(LCD_E | LCD_RW | LCD_D4 | LCD_D5 | LCD_D6 | LCD_D7);
        
        lcddata = lcd_read_i2c();
        lcd_write_i2c(0x00);
        return lcddata;
}
*/